import { TestFrameworkAdapter } from '../serenity-protractor/framework';
export declare class CucumberTestFramework implements TestFrameworkAdapter {
    private requireRoot;
    private args;
    constructor(requireRoot: string, config: CucumberConfig);
    run(specs: string[]): PromiseLike<any>;
    private serenityCucumberModule;
    private stageCue;
    private argumentsFrom(config);
}
export interface CucumberConfig {
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#transpilers
     */
    compiler?: string;
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#formats
     */
    format?: string;
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#format-options
     */
    formatOptions?: string;
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#running-specific-features
     */
    name?: string[];
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#profiles
     */
    profile?: string[];
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#requiring-support-files
     */
    require?: string[];
    /**
     * @link https://docs.cucumber.io/tag-expressions/
     */
    tags?: string[];
    /**
     * @link https://github.com/angular/protractor/blob/e5a5d59fcabe15860b30944e714bbd8e81ceaeae/docs/frameworks.md#using-cucumber
     */
    strict?: boolean;
    'no-colors'?: boolean;
    /**
     * @link https://github.com/cucumber/cucumber-js/blob/master/docs/cli.md#world-parameters
     */
    worldParameters?: string;
}
