import { Interaction, UsesAbilities } from '@serenity-js/core/lib/screenplay';
import { Target } from '../ui/target';
export declare class Execute {
    static script: (...lines: string[]) => ExecuteScript;
    static fn: (fn: Function) => ExecuteScript;
    static asyncScript: (...lines: string[]) => ExecuteAsyncScript;
    static asyncFn: (fn: Function) => ExecuteAsyncScript;
}
export declare class ExecuteScript implements Interaction {
    private readonly script;
    private readonly args;
    performAs(actor: UsesAbilities): PromiseLike<any>;
    on: (target: Target) => ExecuteScript;
    withArguments: (...args: any[]) => ExecuteScript;
    constructor(script: string | Function, args?: any[]);
}
export declare class ExecuteAsyncScript implements Interaction {
    private readonly script;
    private args;
    performAs(actor: UsesAbilities): PromiseLike<any>;
    on: (target: Target) => ExecuteAsyncScript;
    withArguments: (...args: any[]) => ExecuteAsyncScript;
    constructor(script: string | Function, args?: any[]);
}
